//********************************************************************
//*** ResourcePool/SQL/Instances.cc
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: Instances.cc,v 1.8 2005/08/13 18:36:32 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "ResourcePool/ResourcePool.hh"
#include "ResourcePool/ResourcePool.cc"
#include "ResourcePool/Execute.cc"
#include "ResourcePool/Command.cc"
#include "ResourcePool/SQL/Factory.cc"
#include "ResourcePool/SQL/Resource.cc"
#include "ResourcePool/SQL/ResourcePool.hh"

namespace fatalmind {
namespace SQL {

template class SQLFactory<DefaultThreadedModel>;
//template class SQLFactory<MultiThreadedModel<> >;

template class SQLResource<DefaultThreadedModel>;
//template class SQLResource<MultiThreadedModel<> >;

} // namespace SQL

template class ResourcePool<ResourceType::SQL>;
template class Command<ResourceType::SQL>;

} //namespace fatalmind

