//********************************************************************
//*** ResourcePool/mysql/lex.mysql_connect.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: lex.mysql_connect.hh,v 1.2 2005/01/06 16:27:58 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef RESOURCEPOOL_MYSQL_MYSQLCONNECT_HH
#define RESOURCEPOOL_MYSQL_MYSQLCONNECT_HH

#include <string>
#include <sstream>

#ifndef MYSQL_INCLUDE_FLEXLEXER
#undef yyFlexLexer
#define yyFlexLexer mysql_connectFlexLexer
#include <FlexLexer.h>
#endif

namespace fatalmind {

class mysql_connect: public mysql_connectFlexLexer {
	public:
		mysql_connect(const std::string& host, const std::string& user, const std::string& pass, const std::string& db, int port);
		mysql_connect(const std::string& connect);
		mysql_connect(const mysql_connect& mc);

		std::string getHost() const;
		std::string getUser() const;
		std::string getPass() const;
		std::string getDb()   const;
		int         getPort() const;

	private:
		void _validate() const;
		void _parsingError(char ch) const;
		int yylex ();
	
		std::string        _host;
		std::string        _user;
		std::string        _pass;
		std::string        _db;
		int                _port;
};
} // namespace fatalmind

extern "C" {
inline int mysql_connectwrap() {
	return 1;
}
}
#endif
