//********************************************************************
//*** Thread/LockStatistics.cc
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: LockStatistics.cc,v 1.7 2005/01/06 16:28:06 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef INCLUDED_THREAD_LOCKSTATISTICS_HH
#include "Thread/LockStatistics.hh"
#endif

#include <iostream>

namespace fatalmind {

template<class UsagePattern, class TimingPattern>
std::ostream& operator<<(std::ostream& o
	, const LockStatistics<UsagePattern, TimingPattern>& ls
) {
	return o << "Lock statistics for " << &ls << std::endl
		<< static_cast<const UsagePattern&>(ls) << static_cast<const TimingPattern&>(ls);
}

std::ostream& operator<<(std::ostream& o, const NopLockUsageStatistics& s) {
	return o << "   No usage statistics available" << std::endl;
}

std::ostream& operator<<(std::ostream& o, const LockUsageStatistics& s) {
	return o << "   Usage : [lock=" << s._lock << ";maxrec=" << s._maxreclev << "]" << std::endl;
}

std::ostream& operator<<(std::ostream& o, const NopLockTimingStatistics& s) {
    return o << "   No timeing statistics available " << std::endl;
}

std::ostream& operator<<(std::ostream& o, const LockTimingStatistics& s) {
    return o << "   Timing: [wait=" << s._waittime << "]" << std::endl;
}

}
