//********************************************************************
//*** Thread/WaitObject.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: WaitObject.hh,v 1.1 2005/05/10 19:18:50 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef THREAD_WAITOBJECT_HH
#define THREAD_WAITOBJECT_HH

#include "Thread/Lock.hh"

namespace fatalmind {

class WaitObject {
	public:
		WaitObject();
		~WaitObject();

		void done();
		void wait();
	private:
		typedef FastLock<>  lock_t;
		typedef Synchronize<lock_t> sync_t;
		CondVar<lock_t>     _condvar;
		bool                _done;

		WaitObject(const WaitObject&); // c-ctor hidden
};

} // namespace fatalmind

#endif
