//********************************************************************
//*** mm/RefWrap.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: RefWrap.hh,v 1.4 2005/01/06 16:28:09 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of 
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#ifndef MM_REFWRAP_HH
#define MM_REFWRAP_HH

namespace fatalmind {

template<class PR>
class RefWrap {
	public:
		RefWrap()
		: _pr()
		{
		}

		RefWrap(const PR& pr)
		: _pr(const_cast<PR*>(&pr))
		{
		}

		RefWrap(const RefWrap<PR>& rho)
		: _pr(rho._pr)
		{
		}

		RefWrap<PR>& operator=(const RefWrap<PR>& rho) {
			_pr = rho._pr;
			return *this;
		}

		bool operator<(const RefWrap<PR>& rho) const
		{
			return _pr < rho._pr;
		}

		PR& getRef() const {
			return *_pr;
		}
	private:
		PR* _pr;
};

} // namespace fatalmind
#endif
